void main()
{
register char cr, dr;
static char *piapa, *piapb, *piapc, *piactl, *uartdr, *uartcr;
   

   piapa = 0x5001;	/* subtract 4000 for DS offset */
   piapb = 0x5003;
   piapc = 0x5005;
   piactl = 0x5007;   
   uartdr = 0x4000;	/* UART data register */
   uartcr = 0x4002;	/* UART control register */

   *piactl = 0x99;	/* PIA port A and C inputs, port B output */

   *uartcr = 0x0;	
   *uartcr = 0x0;	/* assume worst case UART powerup; reset */
   *uartcr = 0x0;
   *uartcr = 0x40;

   *uartcr = 0xCD;	/* 2 stop bits, parity disabled, 8 bits long, /1  */
   *uartcr = 0x36;	/* enable Rx, DTR low, reset error, RTS low        */
   
   while (1)
     {
     cr = *uartcr;		/* UART status read */

     if (cr==(char)0x87)	/* if full, read UART */
        {
	*uartcr = 0x32;		/* disable Rx */
        dr = *uartdr;
        switch (dr)
		{
		case '0':
			*piapb = 0x0;
			break;
		case '1':
			*piapb = 0x1;
			break;
		case '2':
			*piapb = 0x2;
			break;
		case '3':
			*piapb = 0x3;
			break;
		case '4':
			*piapb = 0x4;
			break;
		default:
			break;
		}
	*uartcr = 0x36;
	}
     }
}
